Page MenuHomePhabricator

Document checklist for releasing a new feature
Closed, DuplicatePublic

Description

https://phabricator.wikimedia.org/T116676#1834698 and followup comments made me wonder if https://www.mediawiki.org/wiki/WMF_product_development_process should have/document a checklist for releasing a new feature, from early concept to build and release.

Related Objects

StatusAssignedTask
DuplicateNone
OpenNone
OpenNone
OpenNone
OpenNone
OpenNone
OpenNone
OpenNone
DuplicateNone
ResolvedKeegan
OpenNone
InvalidKeegan
DeclinedKeegan
ResolvedKeegan
DeclinedNone
ResolvedKeegan
DeclinedNone
ResolvedMoushira
StalledNone
OpenNone
Resolved Qgil
ResolvedKeegan
ResolvedKeegan
OpenNone
ResolvedMoushira
ResolvedQuiddity

Event Timeline

Aklapper created this task.Nov 30 2015, 6:27 PM
Aklapper raised the priority of this task from to Needs Triage.
Aklapper updated the task description. (Show Details)
Aklapper added subscribers: Aklapper, Qgil.
Restricted Application added a subscriber: StudiesWorld. · View Herald TranscriptNov 30 2015, 6:27 PM
Aklapper updated the task description. (Show Details)Nov 30 2015, 6:27 PM
Aklapper set Security to None.

@Aklapper the Community Liaison team created a prototype of such a checklist at our team off-site in July. @Rdicerb @Moushira @Quiddity did this make it past the flipchart stage? I don't recall and can't immediately find it on a wiki.

@Keegan our notes/docs should all be linked at the bottom of https://office.wikimedia.org/wiki/Community_Engagement_%28Product%29/Mexico/Off-site but I don't think we ever turned the detailed/thorough notes into anything, just a brief slides version so far. I'd love for the comprehensive version (as well as lightweight overview) to be fully produced.

In terms of WMF product development process, I would focus this task on the checklist for a project to enter the Release stage. Projects would reach this point after having gone through Concept, Plan, Design, Build, stages that will have their own checklists which, for practical reasons, I would leave out of this task.

I imagine that checklist containing a small set of points required for any new product or feature (i.e. beta version for testing announced and available for at least X time). Additional points would be optional, or required depending on the impact of the product/feature (i.e. if you are replacing an existing workflow, or if you are changing something in the UX for readers...)

There should also be a definition of low impact changes not requiring this checklist (clear example: a bugfix doesn't require any of this; the patch can be deployed as soon as it has been tested, using the regular process by the Release-Engineering-Team (CCed to this task so they are aware we are discussing it).

It sounds like a good individual or team goal for Community-Relations-Support to be agreed with Product. This checklist will also help answering @Tnegrin's question about how to release small/medium features efficiently.

There is a related topic at the WMF product development discussion page. To avoid duplication, it is better to use that page for discussion, and this task to track progress.

Qgil added a subtask: Unknown Object (Task).Dec 1 2015, 9:25 AM
Qgil mentioned this in Unknown Object (Task).Dec 1 2015, 9:30 AM
Qgil added a parent task: Unknown Object (Task).Dec 1 2015, 9:40 AM
Elitre closed subtask Unknown Object (Task) as Invalid.Dec 15 2015, 5:40 PM
greg edited subscribers, added: greg; removed: Release-Engineering-Team.Jan 6 2016, 6:00 PM
Elitre added a subscriber: Elitre.Feb 17 2016, 10:56 AM
Qgil triaged this task as Low priority.Apr 5 2016, 9:25 AM
  • T119891: Document checklist for releasing a new feature - this is complicated, there is no one size fits all checklist, or series of checklists, for releasing a new feature. Each project/product/feature is so very different that treating them with generalities and not nuance is unfair to the end goal. If there is such a possible specific checklist, Risker's one for releasing anything that touches what people use to edit is a good one. That's about as scoped as I would get such a checklist, otherwise it's too restrictive. Risker's checklist is on point because it outlines paths of development that the community will consider harmful.

+1. (as I'm not sure if Keegan was asked as assignee, or me as task author, or....)